<template>
  <div class="gris">
    <div>
      <div class="titulo">
        <div class="ruta">
          <v-breadcrumbs :items="breadcrumbs" :large="false">
            <template v-slot:divider>
              <v-icon>mdi-chevron-right</v-icon>
            </template>
          </v-breadcrumbs>
        </div>
        <strong>Galería de Evidencia</strong>
      </div>

      <div class="titSecCard">
        <strong>Bienvenido a Certificación de calidad.</strong> Información con
        corte al {{ this.dia }} de {{ this.mes }} {{ this.anio }}
      </div>
      <strong>Buscador de Evidencias. </strong>Localiza la evidencia que
      requieras de un recorrido de certificación.
      <v-container fluid>
        <v-row>
          <v-col cols="3">
            <div class="">
              <div>
                <v-autocomplete
                  v-model="searchPuntoContacto"
                  :loading="isSearching"
                  :items="metadata.puntosContacto"
                  clearable
                  hide-no-data
                  hide-details
                  hide-selected
                  :search-input.sync="cecoIngresado"
                  item-text="puntoContacto_descripcion"
                  item-value="puntoContacto_descripcion"
                  placeholder="Escribe el nombre o ID del Punto de Contacto"
                  label="Punto de Venta"
                  return-object
                  outlined
                ></v-autocomplete>
              </div>
            </div>
          </v-col>
          <v-col cols="3">
            <v-combobox
              v-model="selectPeriodo"
              :items="itemsPeriodo"
              label="Periodo"
              outlined
            ></v-combobox>
          </v-col>
          <v-col cols="3">
            <v-combobox
              v-model="selectAnio"
              :items="itemsAnio"
              label="Año"
              outlined
            ></v-combobox>
          </v-col>
          <v-col>
            <!-- BUSCAR -->
            <v-col>
              <v-btn block color="primary" @click="getPuntoContacto" dark>
                <strong style="font-size: 16px; color: #000"
                  >Buscar Evidencia</strong
                >
              </v-btn>
            </v-col>
          </v-col>
        </v-row>
      </v-container>
    </div>
    <div class="titSecCard" v-show="infoSucursalResult">
      <strong
        >{{ this.searchPuntoContacto.id_ceco }} -
        {{ this.searchPuntoContacto.punto_contacto }}</strong
      >
      Visitas de Certificación que coinciden con la búsqueda.
    </div>
    <v-data-table
      v-show="infoSucursalResult"
      :headers="headers"
      :items="items"
      :page.sync="page"
      :items-per-page="itemsPerPage"
      hide-default-footer
      @page-count="pageCount = $event"
      :search="search"
      class="tblGeneral tblHallazgos"
    >
      <template v-slot:item="row">
        <tr>
          <td align="center">
            {{ (row.item.fecha_visita = row.item.fecha_certificacion) }}
          </td>
          <td align="center">
            <router-link
              class="liga"
              style="color: #2d2926"
              :to="{
                name: 'certificacion_calidad_certificacion_detalle',

                params: { visita: serviceCommons.objectToBase64(row.item) },
              }"
            >
              {{ row.item.detalle_certificacion }}</router-link
            >
          </td>

          <td align="center">
            <div style="display: inline-block; float: center">
              <span
                class="circulo"
                v-bind:style="{ background: row.item.rango }"
              ></span
              ><strong style="vertical-align: top">
                {{ row.item.calificacion }}</strong
              >
            </div>
          </td>
          <td align="center">
            {{ row.item.nombre_usuario }}
          </td>
        </tr>
      </template></v-data-table
    >
    <div class="text-center pt-2" v-show="infoSucursalResult">
      <v-pagination
        v-model="page"
        :length="pageCount"
        class="paginador"
      ></v-pagination>
    </div>
  </div>
</template>

<style scoped>
.circulo {
  width: 20px;
  height: 20px;
  border-radius: 50%;
  display: inline-block;
}
</style>
<script>
import router from "@/router";
import store from "@/store";
const axiosChecklist = store.state.axiosChecklist;
import axios from "axios";
import TablaPuntoVentaUltCertificacion from "@/views/secure/certificacion-calidad/components/TablaPuntoVentaUltCert009.vue";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
export default {
  props: {},
  name: "DashboardInvitado",
  components: {},
  data() {
    return {
      serviceCommons,
      cecoIngresado: null,
      dia: 0,
      mes: "",
      anio: 0,
      months: [
        "Enero",
        "Febrero",
        "Marzo",
        "Abril",
        "Mayo",
        "Junio",
        "Julio",
        "Agosto",
        "Septiembre",
        "Octubre",
        "Noviembre",
        "Diciembre",
      ],
      infoSucursalResult: false,
      items: [],
      page: 1,
      pageCount: 1,
      itemsPerPage: 10,
      search: "",
      idCecobase: null,
      idCeco: null,
      propiedades_footer: {
        itemsPerPageOptions: [2, 4, 5, 10],
      },

      searchPuntoContacto: [],

      searchPuntoContactoSync: null,
      metadata: {
        puntosContacto: [],
      },
      isSearching: false,
      isLoadingPuntoContacto: false,
      //isLoadingPuntoContacto: false,
      defaultDataPuntoContacto: null,
      puntoContactoBackup: null,
      infoPuntoContactoResult: false,
      puntoContacto: {
        punto_contacto: null,
      },
      headers: [
        {
          text: "Fecha",
          value: "fecha_certificacion",
          align: "center",
        },
        {
          text: "Certificación",
          value: "detalle_certificacion",
          align: "center",
        },
        {
          text: "Calificación",
          value: "calificacion_certificacion",
          align: "center",
        },
        {
          text: "Certificador",
          value: "certificador",
          align: "center",
        },
      ],
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Modelo de Revisión en Sitio",
          disabled: false,
          exact: true,
          to: {
            name: "certificacion_calidad_director",
          },
        },
        {
          text: "Dashboard Invitado",
          disabled: true,
        },
      ],
      fechaInicial: "",
      selectPeriodo: ["1er Trimestre"],
      selectAnio: ["2020"],
      itemsPeriodo: [
        //PENDIENTE : Obtener los catalogos periodo y año WS
        "1er Trimestre",
        "2do Trimestre",
        "3er Trimestre",
        "4to Trimestre",
        "Todo el año"
      ],
      itemsAnio: ["2020","2021"],
    };
  },
  watch: {
    searchPuntoContactoSync(val) {
      if (!val) {
        this.searchGerente = null;
        this.invokeDefaultEmpyDataPuntoContacto();
      }
    },
  },
  mounted() {
    this.getDateYesterday();
  },
  created() {
    //this.snapshotDataPuntoContacto();
    this.getPuntosContacto();
    //this.getCecosV2();
  },

  methods: {
    getFecha() {
      if (this.selectPeriodo == "1er Trimestre") {
        this.fechaInicial = "01/01/" + this.selectAnio;
        this.fechaFinal = "31/03/" + + this.selectAnio;
      }
      if (this.selectPeriodo == "2do Trimestre") {
        this.fechaInicial = "01/04/" +  this.selectAnio;
        this.fechaFinal = "30/06/" + this.selectAnio;
      }
      if (this.selectPeriodo == "3er Trimestre") {
        this.fechaInicial = "01/07/" + this.selectAnio;
        this.fechaFinal = "30/09/" + this.selectAnio;
      }
      if (this.selectPeriodo == "4to Trimestre") {
        this.fechaInicial = "01/10/"+ this.selectAnio;
        this.fechaFinal = "31/12/" + this.selectAnio;
      }

      if(this.selectPeriodo == "Todo el año"){
        this.fechaInicial = "01/01/" + this.selectAnio;
        this.fechaFinal = "31/12/" + this.selectAnio;
      }
      //  this.getPuntoContacto();
    },
    getDateYesterday() {
      var date = new Date();
      date.setDate(date.getDate() - 1);
      this.dia = date.getDate();
      this.mes = this.months[date.getMonth()];
      this.anio = date.getFullYear();
    },
    getPuntosVentaCertificados() {},

    actualizaCecos() {
      //console.log("Entre para llenar los cecos");
      if (this.cecoIngresado != null && this.cecoIngresado.length > 3) {
        this.getCecosV2();
      } else if (this.cecoIngresado == null || this.cecoIngresado == "") {
        this.metadata.puntosContacto = [];
      }
    },

    getCecosV2() {
      axios
        .get("ceco/secure/get/ceco/all")
        .then(response => {
          if (response) {
            if (response.status === 200) {
               this.metadata.puntosContacto = [];
              console.log("Respuesta recibida = ");
              for (var i = 0; i < response.data.data.length; i++) {
                this.metadata.puntosContacto.push({
                    punto_contacto: response.data.data[i].descripcion,
                    id_ceco: response.data.data[i].id_ceco,
                    puntoContacto_descripcion:
                      response.data.data[i].id_ceco +
                      " - " +
                      response.data.data[i].descripcion,
                  });
              }
            }
          }
        })
        .catch(error => {
          console.log(error);
        })
        .finally(function() {});
    },

    getCecos() {
      axios
        .post("ceco/secure/post/ceco/gen", {
          id_veco: this.cecoIngresado, 
        })
        .then((response) => {
          if (response) {
            if (response.status === 200) {
              this.metadata.puntosContacto = [];
              for (var i = 0; i < response.data.data.length; i++) {
                //Solo se permiten los 48,92,55  Puntos de Venta. //PENDIENTE generar script BD
                let prefijo = response.data.data[i].id_ceco.substring(0, 2);
                if (prefijo === "48" || prefijo === "92" || prefijo === "55") {
                  this.metadata.puntosContacto.push({
                    punto_contacto: response.data.data[i].descripcion,
                    id_ceco: response.data.data[i].id_ceco,
                    puntoContacto_descripcion:
                      response.data.data[i].id_ceco +
                      " - " +
                      response.data.data[i].descripcion,
                  });
                }
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function () {});
    },

    getPuntosContacto() {
      var self = this;
      self.isLoadingPuntosContacto = true;
      axios
        .get("/franquicia/dashboard/consulta/secure/buscador/get/ceco")
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              const data = response.data.data;
              if (data) {
                
                self.setPuntosContacto(data);
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function () {
          self.isLoadingPuntosContacto = false;
        });
    },
    setPuntosContacto(data) {
      if (data) {
        data = data.filter((item, index) => {
          item.puntoContacto_descripcion =
            item.id_ceco + " - " + item.punto_contacto;
          this.idCeco = item.id_ceco;
          this.idCecobase = item.id_ceco_base;
          return item;
        });
      }
      this.metadata.puntosContacto = data;
    },
    getPuntoContacto() {
      this.getFecha();
      const self = this;
      let url =
        "/franquicia/dashboard/g014/secure/grafico/get/certificaciones/previas/?" +
        "idCeco=" +
        this.searchPuntoContacto.id_ceco +
        "&" +
        //"idCecoBase=" +
        //this.searchPuntoContacto.id_ceco_base +
        //"&" +
        "fechaInicial=" +
        this.fechaInicial +
        "&" +
        "fechaFinal=" +
        this.fechaFinal +
        "&idUsuario=" +
        "&" +
        "idInvitado=0";
      axios
        .get(url)
        .then((response) => {
          if (response) {
            if (response.data.status_code === 200) {
              self.infoSucursalResult = true;
              const data = response.data.data;
              if (data) {
                data.forEach((element) => {
                  element.fecha_certificacion = element.fecha;

                  element.detalle_certificacion = "Detalle de la certificación";
                  element.certificador = element.nombre_usuario;
                  element.calificacion_certificacion = element.calificacion;
                  element.rango = element.rango_color;

                  if (element.hora_entrada) {
                    element.hora_entrada = element.hora_entrada + " hrs";
                  }

                  if (element.hora_salida) {
                    element.hora_salida = element.hora_salida + " hrs";
                  }

                  if (element.fecha_certificacion) {
                    let fecha = element.fecha_certificacion.split(" ")[0];
                    let dia = fecha.split("-")[2];
                    let mes = fecha.split("-")[1];
                    let anio = fecha.split("-")[0];

                    element.fecha_certificacion = dia + "/" + mes + "/" + anio;
                  }
                });
                self.items = data;
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    setPuntoContacto(data) {
      if (data) {
        data = data.filter((item, index) => {
          item.puntoContacto_descripcion = item.punto_contacto;
          return item;
        });
      }
      this.metadata.puntosContacto = data;
    },
    snapshotDataPuntoContacto() {
      let puntoContacto = JSON.stringify(this.puntoContacto);
      this.defaultDataPuntoContacto = JSON.parse(puntoContacto);
    },
    invokeDefaultEmpyDataPuntoContacto() {
      let puntoContacto = JSON.parse(
        JSON.stringify(this.defaultDataPuntoContacto)
      );
      this.puntoContacto = puntoContacto;
      this.$v.$reset();
    },
  },
};
</script>
